// s[gET[oEvO(|[g 3000 gp)
// \PbgEIvVgp
// NCAg瑗Ăԍɂă[^[PWMs

#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define PORT 3000

static char *LED[] = {
	"/home/root/led0",
	"/home/root/led1",
	"/home/root/led2",
	"/home/root/led3"
};

static char *MES1[] = {
	"Pos. ",
	"Neg. "
};

static char *MES2[] = {
	"Speed0",
	"Speed1",
	"Speed2",
	"Speed3",
	"Speed4",
	"Speed5",
	"Speed6",
	"Speed7"
};

int main (int argc, char *argv[])
{
	int fd_socket, fd_accept, index, i;
	int led_fd[4];
	size_t len;
	struct sockaddr_in addr;
	char buff[BUFSIZ];

	if ((fd_socket = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("Server : socket :");
		return 1;
	}
	index = 1;
	setsockopt(fd_socket, SOL_SOCKET, SO_REUSEADDR, &index, sizeof(index)); 

	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = INADDR_ANY; 
	addr.sin_port = htons(PORT);

	if ((bind(fd_socket, (struct sockaddr *) &addr, 
		sizeof(addr))) == -1) {
		perror("S-bind:");
		return 1;
	}

	if ((listen(fd_socket, 5)) == -1) {
		perror("S-listen:"); 
		return 1;
	}

	while(1) {
		if ((fd_accept = accept(fd_socket, 
			(struct sockaddr *) &addr, &len)) == -1) {
			perror("S-accept:"); 
			return 1;
		}

		if ((read(fd_accept, buff, BUFSIZ)) == -1) {
			perror("S-read:");
			return 1;
		}

		index = atoi(buff);

		if (index == 16) {
			strcpy(buff, "Server finshed.\n");
			goto loop_last;
		}
		if (index > 16) {
			strcpy(buff, "Invalid Index.\n");
			goto loop_last;
		}
		strcpy(buff, MES1[(index & 0x08) >> 3]);
		strcpy(buff + strlen(MES1[(index & 0x08) >> 3]), MES2[(index & 0x07)]);
		for (i = 0; i <= 3; i++) {
			if ((led_fd[i] = open(LED[i], O_WRONLY)) == -1) {
				perror("open:");
				return 1;
			}
			if ((index & (0x01 << i)) == (0x01 << i)){
				write(led_fd[i], "1", 1); 
			}
			else{
				write(led_fd[i], "0", 1); 
			}
			close(led_fd[i]);
		}
loop_last :	if ((write(fd_accept, buff, strlen(buff) + 1)) == -1) {
			perror("S-write");
			return 1;
		}

		close(fd_accept);
		if (index == 16)
			break;
	}
	close(fd_socket); 

	return 0;
}
